'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fns = require('../lib/fns');

var _gulp = require('../gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _bundler = require('../bundler');

var _bundler2 = _interopRequireDefault(_bundler);

var _copy = require('./copy');

var _copy2 = _interopRequireDefault(_copy);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _makeTemplate = require('./makeTemplate');

var _makeTemplate2 = _interopRequireDefault(_makeTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var ref = _asyncToGenerator(function* () {
    try {
      print(`\n  Building...`.dim);

      (0, _makeTemplate2.default)();

      yield Promise.all([_gulp2.default.app(), _gulp2.default.styles(), _copy2.default.motion(), _copy2.default.react()]);

      print(`\n  Built! ⇢`.green.bold + `  cd ${ buildDir() }`);
    } catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function build() {
    return ref.apply(this, arguments);
  };
}();

function buildDir() {
  return _fns.path.relative((0, _opts2.default)('appDir'), (0, _opts2.default)('buildDir'));
}
//# sourceMappingURL=build.js.map