'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = webpacker;

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _getWebpackErrors = require('./getWebpackErrors');

var _getWebpackErrors2 = _interopRequireDefault(_getWebpackErrors);

var _fns = require('../../lib/fns');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function webpacker(name, config, cb) {
  return new Promise((res, rej) => {
    const compiler = (0, _webpack2.default)(config);
    const watching = (0, _opts2.default)('watch') || !(0, _opts2.default)('build');

    // continue if watching
    if (watching) res();

    const run = watching ? compiler.watch.bind(compiler, {}) : compiler.run.bind(compiler);

    run((e, stats) => {
      _fns.log.externals('ran webpack', name);
      const err = (0, _getWebpackErrors2.default)('externals', e, stats);

      if (err) {
        (0, _fns.logError)(err);
        rej(err);
      } else {
        _fns.emitter.emit('compiler:' + name);
        cb();
        res();
      }
    });
  });
}
//# sourceMappingURL=webpack.js.map