'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.file = file;
exports.app = app;
exports.getBabelConfig = getBabelConfig;

var _motionTransform = require('motion-transform');

var _motionTransform2 = _interopRequireDefault(_motionTransform);

var _helpers = require('./helpers');

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function file(config) {
  const motionOpts = _extends({
    basePath: (0, _opts2.default)('appDir'),
    production: (0, _helpers.isProduction)(),
    selectorPrefix: (0, _opts2.default)('config').selectorPrefix || '#_motionapp ',
    routing: (0, _opts2.default)('config').routing
  }, config);

  return getBabelConfig({
    plugins: [_motionTransform2.default.file(motionOpts)]
  });
}

function app() {
  return {
    whitelist: [],
    retainLines: true,
    comments: true,
    plugins: [_motionTransform2.default.app({ name: (0, _opts2.default)('saneName') })],
    compact: true,
    extra: { production: (0, _helpers.isProduction)() }
  };
}

function getBabelConfig(_ref) {
  let plugins = _ref.plugins;

  const babelConf = {
    breakConfig: true, // avoid reading .babelrc
    jsxPragma: 'view.el',
    stage: 1,
    blacklist: ['es6.tailCall', 'strict'],
    retainLines: (0, _opts2.default)('config').pretty ? false : true,
    comments: true,
    optional: ['regenerator', 'runtime'],
    plugins,
    extra: {
      production: (0, _helpers.isProduction)()
    }
  };

  const userConf = (0, _opts2.default)('config').babel;

  if (userConf) return (0, _deepmerge2.default)(babelConf, userConf);else return babelConf;
}

exports.default = {
  app,
  file
};
//# sourceMappingURL=config.js.map